﻿using System;

// Product interface
public interface IProduct
{
    void Operation();
}

// ConcreteProductA class
public class ConcreteProductA : IProduct
{
    public void Operation()
    {
        Console.WriteLine("ConcreteProductA operation");
    }
}

// ConcreteProductB class
public class ConcreteProductB : IProduct
{
    public void Operation()
    {
        Console.WriteLine("ConcreteProductB operation");
    }
}

// ConcreteProductC class
public class ConcreteProductC : IProduct
{
    public void Operation()
    {
        Console.WriteLine("ConcreteProductC operation");
    }
}

// Creator abstract class
public abstract class Creator
{
    public abstract IProduct Create();

    public void SomeOperation()
    {
        // You can add some logic here
        Console.WriteLine("Doing some other operations in the creator");
    }
}

// ConcreteCreator class
public class ConcreteCreator : Creator
{
    public override IProduct Create()
    {
        Console.Write("Which product to create? A, B or C? ");
        char choice = char.ToLower(Console.ReadKey().KeyChar);
        Console.WriteLine();

        switch (choice)
        {
            case 'a':
                return new ConcreteProductA();
            case 'b':
                return new ConcreteProductB();
            case 'c':
                return new ConcreteProductC();
            default:
                throw new InvalidOperationException("Invalid choice. Please select A, B, or C.");
        }
    }
}

class Program
{
    static void Main()
    {
        Creator creator = new ConcreteCreator();
        IProduct product = creator.Create();
        if (product != null)
        {
            product.Operation();
        }

        Console.ReadKey();
    }
}
